#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    string rec;
    cin>>rec;
    int d=rec.size();
    int dp[3000]={0};
    for(int i=2; i<d-1; i++)
    {
        int br=i-2, p=0;
        for(int j=i-1, k=i; j>=0; j--, k++)
        {
            if(k<d)
            {
                if(rec[j]==rec[k])p+=1;
                if(j==br){dp[i]=max(dp[i], dp[br]+p); br--;}
            }
            else
            {
                if(j==br){dp[i]=max(dp[i], dp[br]+p); br--;}
            }
        }
    }
    for(int i=2; i<d-1; i++)cout<<dp[i]<<endl;
    cout<<max(dp[d-2], dp[d-3]);
    return 0;
}
/* aa
  baa
  aaa
   aa*/